chiark / gitweb /
dot/mc-panels.ini: More useful default.
[profile] / setup
... / ...
CommitLineData
1#! /bin/bash
2
3set -e
4
5###--------------------------------------------------------------------------
6### Basic setup.
7
8umask 002
9
10sub=
11mkdir -p $HOME$sub
12
13: ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17###--------------------------------------------------------------------------
18### Sort out command line.
19
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
36here=$(pwd)
37
38## Suss out how to print things
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
48## Find out how to fetch things over the net
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
80echo "Installing packages..."
81systems="
82 mlib:crc-mktab
83 checkpath:tmpdir
84"
85[ "$xstuff" ] && systems="$systems
86 xtoys:xatom
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
90 sys=$1 prog=$2
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100 $echon " unpacking$echoc"
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
103 $echon " configuring$echoc"
104 cd $dir
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115done
116echo " all done."
117
118###--------------------------------------------------------------------------
119### Install global configuration.
120
121echo -n "Installing dotfile configuration:"
122if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127fi
128
129## Symlink the various dotfiles into place
130dotfiles="
131 bash_profile bash_logout bashrc inputrc bash_completion
132 emacs emacs-calc vm gnus.el ercrc.el
133 vimrc mg zile
134 ditz-config
135 mailrc signature
136 cgrc tigrc
137 gdbinit
138 guile
139 rcrc
140 toprc
141 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
142 aspell.conf
143 tclshrc:.tclshrc tclshrc:.wishrc
144 lisp-init.lisp:.cmucl-init.lisp
145 lisp-init.lisp:.sbclrc
146 lisp-init.lisp:.clisprc.lisp
147 lisp-init.lisp:.eclrc
148 swank.lisp
149 dircolors colordiffrc screenrc cvsrc indent.pro"
150[ "$xstuff" ] && dotfiles="$dotfiles
151 xinitrc xsession Xdefaults vncrc vncsession
152 fonts.conf
153 stalonetrayrc
154 putty-defaults:.putty/sessions/Default%20Settings
155 mdw.session:.config/gnome-session/sessions/mdw.session
156 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
157 e-keybindings.cfg:.enlightenment/keybindings.cfg
158 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
159 e16-bindings:.e16/bindings.cfg"
160echo "Installing dotfiles..."
161for d in $dotfiles; do
162 target=.$d
163 case $d in
164 *:*) target=${d#*:} d=${d%%:*};;
165 esac
166 ft=$HOME$sub/$target
167 dir=${ft%/*}
168 mkdir -p $dir
169 ln -s $here/dot/$d $ft.new
170 mv $ft.new $ft
171 echo " $target"
172done
173echo " all done."
174
175## Substitute things which need substituting.
176dotfilessubst="
177 gitconfig
178 pulse-default.pa.in:.pulse/default.pa"
179echo "Installing dotfiles with substitutions..."
180for d in $dotfilessubst; do
181 case $d in
182 *:*) target=${d#*:} d=${d%%:*};;
183 *) target=.$d d=$d.in;;
184 esac
185 ft=$HOME$sub/$target
186 dir=${ft%/*}
187 mkdir -p $dir
188 sed "
1891i\\
190### generated by $here/setup; do not edit!\\
191
192/@home@/ s\a\a$HOME\ag
193/@releasekey@/ s\a\a$(bin/mdw-conf release-key 481334C2)\ag
194/@gitignore@/ s\a\a$(bin/mdw-conf gitignore $here/git/gitignore)\ag
195" dot/$d >$ft.new
196 mv $ft.new $ft
197 echo " $target"
198done
199echo " all done."
200
201## Symlink backgrounds.
202backgrounds="
203 jue-peek.jpg
204 medusa.jpg
205 bsg-supper.jpg
206 rayne.jpg
207 hypatia.jpg
208 noodly.jpg
209 lovelace.jpg"
210if [ "$xstuff" ]; then
211 echo "Installing backgrounds..."
212 for b in $backgrounds; do
213 for e in enlightenment e16; do
214 dir=$HOME$sub/.$e/backgrounds
215 t=$dir/$b
216 mkdir -p $dir
217 ln -s $here/bg/$b $t.new
218 mv $t.new $t
219 done
220 echo " $b"
221 done
222 echo " all done."
223fi
224
225###--------------------------------------------------------------------------
226### Install useful scripts included in this package.
227
228scripts="
229 mdw-editor
230 mdw-pager
231 mdw-conf
232 mdw-build
233 emacsclient-hack
234 movemail-hack
235 sendmail-hack
236 aspell-hack
237 emerge-hack
238 lesspipe.sh
239 start-ssh-agent
240 svnwrap
241 hyperspec"
242[ "$xstuff" ] && scripts="$scripts
243 xinitcmd
244 un-backslashify-selection
245 lock-screen
246 xshutdown"
247echo "Installing scripts..."
248mkdir -p $HOME$sub/bin
249for s in $scripts; do
250 ft=$HOME$sub/bin/$s
251 ln -s $here/bin/$s $ft.new
252 mv $ft.new $ft
253 echo " $s"
254done
255echo " all done."
256
257hacks="
258 ssh:ssh"
259echo "Installing hacks..."
260for h in $hacks; do
261 d=${h%%:*} h=${h#*:}
262 ft=$HOME$sub/bin/hacks/$d
263 mkdir -p $ft
264 ln -s $here/hacks/$h $ft/$h.new
265 mv $ft/$h.new $ft/$h
266 echo " $d:$h"
267done
268echo " all done."
269
270###--------------------------------------------------------------------------
271### Set up the Emacs config.
272
273$echon "Finding a suitable emacs:$echoc"
274emacs=no
275for i in emacs22 emacs23 emacs21 emacs; do
276 if type -p >/dev/null $i; then
277 emacs=$i
278 break
279 fi
280done
281if [ $emacs = no ]; then
282 echo " failed."
283 emacs=:
284else
285 echo " $emacs."
286fi
287
288echo "Installing Emacs packages..."
289emacspkg="
290 make-regexp
291 ew-hols
292 mdw-gnus-patch
293 git git-blame vc-git stgit
294 quilt"
295for elib in $emacspkg; do
296 $echon " $elib:$echoc"
297 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
298 (progn
299 (setq load-path (nconc load-path (list "~/lib/emacs")))
300 (kill-emacs (condition-case nil
301 (progn (load-library "'"$elib"'") 0)
302 (error 1))))'; then
303 echo " already installed."
304 else
305 if [ -f el/$elib.el ]; then
306 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
307 else
308 $echon " downloading$echoc"
309 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
310 fi
311 $echon " compiling$echoc"
312 (cd $HOME$sub/lib/emacs;
313 $emacs >/dev/null 2>&1 --no-site-file --batch \
314 --eval '(byte-compile-file "'"$elib.el"'")')
315 echo " done."
316 fi
317done
318echo " all done."
319
320$echon "Setting up Emacs configuration:$echoc"
321$echon " linking$echoc"
322for f in dot-emacs.el Makefile; do
323 set -- $(echo $link | tr : ' ')
324 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
325 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
326done
327$echon " compiling$echoc"
328make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
329echo " done."
330
331###----- That's all, folks --------------------------------------------------